// noop logger shouldn't be used in browser
export function createConsoleSink(options) {
    function log(data) {
        // eslint-disable-next-line no-console
        console.log(formatLog(data));
    }
    return {
        log,
        trackAction: (message, finalMessage, action) => trackAction(message, finalMessage, action),
    };
}
export function formatLog(log) {
    return JSON.stringify(log);
}
async function trackAction(message, finalMessage, asyncAction) {
    // eslint-disable-next-line no-console
    console.log(message);
    try {
        const result = await asyncAction();
        // eslint-disable-next-line no-console
        console.log(`✓ ${finalMessage}`);
        return result;
    }
    catch (error) {
        // eslint-disable-next-line no-console
        console.log(`x ${message}`);
        throw error;
    }
}
//# sourceMappingURL=console-sink.browser.js.map